// TestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Test.h"
#include "TestDlg.h"
#include <Richole.h>
#include "RichEditCtrlGif.h"
#include "RichEditCtrlGif_i.c"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


IExRichEditOleCallback::IExRichEditOleCallback()
{
	pStorage = NULL;
	m_iNumStorages = 0;
	m_dwRef = 0;

	// set up OLE storage
	HRESULT hResult = ::StgCreateDocfile(NULL,
		STGM_TRANSACTED | STGM_READWRITE | STGM_SHARE_EXCLUSIVE /*| STGM_DELETEONRELEASE */|STGM_CREATE ,
		0, &pStorage );

	if ( pStorage == NULL ||
		hResult != S_OK )
	{
		AfxThrowOleException( hResult );
	}
}

IExRichEditOleCallback::~IExRichEditOleCallback()
{
}

HRESULT STDMETHODCALLTYPE 
IExRichEditOleCallback::GetNewStorage(LPSTORAGE* lplpstg)
{
	m_iNumStorages++;
	WCHAR tName[50];
	swprintf(tName, L"REOLEStorage%d", m_iNumStorages);

	HRESULT hResult = pStorage->CreateStorage(tName, 
		STGM_TRANSACTED | STGM_READWRITE | STGM_SHARE_EXCLUSIVE | STGM_CREATE ,
		0, 0, lplpstg );

	if (hResult != S_OK )
	{
		::AfxThrowOleException( hResult );
	}

	return hResult;
}

HRESULT STDMETHODCALLTYPE 
IExRichEditOleCallback::QueryInterface(REFIID iid, void ** ppvObject)
{

	HRESULT hr = S_OK;
	*ppvObject = NULL;
	
	if ( iid == IID_IUnknown ||
		iid == IID_IRichEditOleCallback )
	{
		*ppvObject = this;
		AddRef();
		hr = NOERROR;
	}
	else
	{
		hr = E_NOINTERFACE;
	}

	return hr;
}

ULONG STDMETHODCALLTYPE 
IExRichEditOleCallback::AddRef()
{
	return ++m_dwRef;
}

ULONG STDMETHODCALLTYPE 
IExRichEditOleCallback::Release()
{
	if ( --m_dwRef == 0 )
	{
		delete this;
		return 0;
	}

	return m_dwRef;
}


HRESULT STDMETHODCALLTYPE 
IExRichEditOleCallback::GetInPlaceContext(LPOLEINPLACEFRAME FAR *lplpFrame,
	LPOLEINPLACEUIWINDOW FAR *lplpDoc, LPOLEINPLACEFRAMEINFO lpFrameInfo)
{
	return S_OK;
}


HRESULT STDMETHODCALLTYPE 
IExRichEditOleCallback::ShowContainerUI(BOOL fShow)
{
	return S_OK;
}


#define GET_X_LPARAM(lp)   ((int)(short)LOWORD(lp))
#define GET_Y_LPARAM(lp)   ((int)(short)HIWORD(lp))


HRESULT STDMETHODCALLTYPE 
IExRichEditOleCallback::QueryInsertObject(LPCLSID lpclsid, LPSTORAGE lpstg, LONG cp)
{
	STATSTG  sg ;
	// lpstg ->Stat ( &sg, 0 ) ;
	//	char sz[200] = {0} ;
	//	WideCharToMultiByte ( CP_ACP, 0, sg .pwcsName, wcslen ( sg .pwcsName ),
	//	 sz, 200, NULL, NULL ) ;
	
	return S_OK;
}


HRESULT STDMETHODCALLTYPE 
IExRichEditOleCallback::DeleteObject(LPOLEOBJECT lpoleobj)
{	
	return S_OK;
}

HRESULT STDMETHODCALLTYPE 
IExRichEditOleCallback::QueryAcceptData(LPDATAOBJECT lpdataobj, CLIPFORMAT FAR *lpcfFormat,
	DWORD reco, BOOL fReally, HGLOBAL hMetaPict)
{
	return S_OK;
}

HRESULT STDMETHODCALLTYPE 
IExRichEditOleCallback::ContextSensitiveHelp(BOOL fEnterMode)
{
	return S_OK;
}

HRESULT STDMETHODCALLTYPE 
IExRichEditOleCallback::GetClipboardData(CHARRANGE FAR *lpchrg, DWORD reco, LPDATAOBJECT FAR *lplpdataobj)
{
	return S_OK;
}

HRESULT STDMETHODCALLTYPE 
IExRichEditOleCallback::GetDragDropEffect(BOOL fDrag, DWORD grfKeyState, LPDWORD pdwEffect)
{
	return S_OK;
}

HRESULT STDMETHODCALLTYPE 
IExRichEditOleCallback::GetContextMenu(WORD seltyp, LPOLEOBJECT lpoleobj, CHARRANGE FAR *lpchrg,
	HMENU FAR *lphmenu)
{
	return S_OK;
}


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestDlg dialog

CTestDlg::CTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTestDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestDlg)
	DDX_Control(pDX, IDC_RICHEDIT, m_rich);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTestDlg, CDialog)
	//{{AFX_MSG_MAP(CTestDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BTN_ADD, OnBtnAdd)
	//}}AFX_MSG_MAP	
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON1, &CTestDlg::OnBnClickedButton1)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestDlg message handlers

BOOL CTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_pIRichEditOleCallback = new IExRichEditOleCallback;
	m_rich .SetOLECallback ( m_pIRichEditOleCallback ) ;
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTestDlg::OnBtnAdd() 
{
	InsertImage ( m_rich .GetIRichEditOle () );
}

BOOL CTestDlg::InsertImage(IRichEditOle* lpRichEditOle)
{	
    IStorage*           lpStorage        = NULL;	
    IOleObject*         lpOleObject      = NULL;	
    LPLOCKBYTES			lpLockBytes      = NULL;	
    IOleClientSite*		lpOleClientSite  = NULL;      
    IRichEditCtrlGif*	lpDynamicGif     = NULL;	
    CLSID               clsid ;	
    REOBJECT			reobject ;	
    HRESULT             hr ;

	::CoInitialize ( NULL ) ; 		    
	
    hr = ::CoCreateInstance(CLSID_RichEditCtrlGif,NULL,CLSCTX_ALL,IID_IRichEditCtrlGif,(LPVOID*)&lpDynamicGif);
	if( lpDynamicGif == NULL )
	{
		::CoUninitialize();
		return FALSE;		
    }

	CString		strUserName = _T("abcdefeghijklmnopqrstuvwxyz1234567890") ;
	CString		strPassword = _T("~!@#$%^&*()<>?") ;

	BSTR		bstrUserName = strUserName .AllocSysString () ;
	BSTR		bstrPassword = strPassword .AllocSysString () ;

	// Setup UserName or Password
	lpDynamicGif ->SetLicense ( bstrUserName, bstrPassword ) ;
	lpDynamicGif ->SetHostWindow ( m_rich .m_hWnd ) ;

	::SysFreeString ( bstrUserName ) ;	
	::SysFreeString ( bstrPassword ) ;	

	BOOL bRet = TRUE ;	   	

    try
	{
		TCHAR bigBuff[2048] = _T("");  // maximum common dialog buffer size
		CString strFilter = _T("Gif Files (*.gif)|*.gif|All Files (*.*)|*.*||");
		CFileDialog dlg ( TRUE, NULL, NULL, OFN_HIDEREADONLY , strFilter);
		
		dlg.DoModal();

		CString		strFile = dlg .GetPathName () ;		
		
		BSTR	bstrFile = strFile .AllocSysString () ;	
		hr = lpDynamicGif->LoadFile(bstrFile);		
		::SysFreeString ( bstrFile ) ;	
		if( hr != S_OK ) 			
			AfxThrowOleException(hr);
		
		hr = lpDynamicGif->QueryInterface(&lpOleObject);		
		if( hr != S_OK ) 			
			AfxThrowOleException(hr);
		
		hr = lpOleObject->GetUserClassID(&clsid);		
		if ( hr != S_OK)			
			AfxThrowOleException(hr);
				
		hr = ::CreateILockBytesOnHGlobal(NULL, TRUE, &lpLockBytes);		
		if (hr != S_OK)			
			AfxThrowOleException(hr);		
		
		hr = ::StgCreateDocfileOnILockBytes(lpLockBytes,			
			STGM_SHARE_EXCLUSIVE|STGM_CREATE|STGM_READWRITE, 0, &lpStorage);		
		if (hr != S_OK)			
		{			
			VERIFY(lpLockBytes->Release() == 0);			
			lpLockBytes = NULL;			
			AfxThrowOleException(hr);			
		}

		OleSetContainedObject(lpOleObject,TRUE);	
		
		lpRichEditOle->GetClientSite(&lpOleClientSite);			
		ZeroMemory(&reobject, sizeof(REOBJECT));        		
		reobject.cbStruct  = sizeof(REOBJECT);	
		reobject.clsid     = clsid;		
		reobject.cp        = REO_CP_SELECTION;		
		reobject.dvaspect  = DVASPECT_CONTENT;		
		reobject.dwFlags   = REO_BELOWBASELINE;		
		reobject.dwUser	   = (DWORD)lpDynamicGif;
		reobject.poleobj   = lpOleObject;		
		reobject.polesite  = lpOleClientSite;		
		reobject.pstg      = lpStorage;		
		
		hr = lpRichEditOle->InsertObject( &reobject );		
		if (hr != S_OK)			
			AfxThrowOleException(hr);		
				
    }	
    catch( COleException* e )		
    {
		TRACE(_T("CImageRichEditCtrl::InsertGifAnimator() OleException code:%d"),e->m_sc);		
		e->Delete();		
		bRet = FALSE;		
    }
		
    // release the interface	
    if( lpDynamicGif    != NULL )   lpDynamicGif->Release();	
    if( lpOleObject     != NULL )   lpOleObject->Release();	
    if( lpOleClientSite != NULL )   lpOleClientSite->Release();	
    if( lpStorage       != NULL )   lpStorage->Release();	

	//Unintialize the COM library  
	CoUninitialize();  

    return bRet;	
}

void CTestDlg::OnDestroy()
{
	m_rich .SetOLECallback ( NULL ) ;
	m_rich .SetSel ( 0, -1 ) ;						
	m_rich .Clear () ;
	m_pIRichEditOleCallback ->Release () ;
	CDialog::OnDestroy();	
}

void CTestDlg::OnBnClickedButton1()
{
	CHARRANGE	rang ;
	m_rich .SetSel ( 0, -1 ) ;
	m_rich .GetSel ( rang ) ;		
	m_rich .Clear () ;		
}
